Bug 914936

Summary: Review Request: fes - Fast Exhaustive Search
Product: [Fedora] Fedora Reporter: Paulo Andrade <paulo.cesar.pereira.de.andrade>
Component: Package ReviewAssignee: Mario Blättermann <mario.blaettermann>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: mario.blaettermann, notting, package-review
Target Milestone: ---Flags: mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: fes-0.1-4.fc19 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-06-20 22:02:03 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Paulo Andrade 2013-02-23 10:36:26 EST
Spec URL: http://pcpa.fedorapeople.org/fes.spec
SRPM URL: http://pcpa.fedorapeople.org/fes-0.1-1.fc19.src.rpm
Description: This external library implements an efficient implement of exhaustive
search to solve systems of low-degree boolean equations. Exhaustive
search is asymptotically faster than computing a Groebner basis,
except in special cases. This particular implementation is
particularly efficient (in the good cases it tests 3 candidate
solutions per CPU cycle on each core).
Fedora Account System Username: pcpa
Comment 1 Mario Blättermann 2013-06-05 14:50:54 EDT
Is it possible to drop the static library? Have a look at the guidelines:
http://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Static_Libraries_2

BuildRequires:	python
This is needed for run a test, I know. The file test_suite.py doesn't say which Python version is needed, so I assume we need Python v2. To be more future-proof, you might use "python(abi) = 2.7" or "python2".

%global		with_doc
Instead of dropping the docs completely, you should build and put them in a -docs subpackage. I think almost no user will rebuild the srpm to get the Texlive docs.

AUTHORS, TODO and COPYING have to be shipped with the -devel package as a minimum documentation. You are anyway forced to have a license text present due to the GPL rules.
Comment 2 Paulo Andrade 2013-06-05 21:01:28 EDT
Many thanks for the review.

I added the new fes-dynamic.patch patch, that required fixing
and/or making compatible with automake 1.13 stuff and removing
some duplicated entries in autogenerated file lists to avoid
adding the same object files more than once to the linker
command line (could add -Wl,mulrefs, but too ugly...)

I can remove the "with_doc" macro if you prefer. It was not added
because of size of the pdf file (100kish) but kind or remaining
of my initial tests in generating documentation, and figuring
out what was required, and the almost full texlive stack is
not always "cheap" to install.

Update:

- Make python2 a build requires (#914936#c1).
- Patch the package to generate a dynamic library (#914936#c1).
- Add AUTHORS, COPYING and TODO to package documentation (#914936#c1).

Spec URL: http://pcpa.fedorapeople.org/fes.spec
SRPM URL: http://pcpa.fedorapeople.org/fes-0.1-2.fc20.src.rpm
Comment 3 Mario Blättermann 2013-06-06 12:55:08 EDT
(In reply to Paulo Andrade from comment #2)
> Many thanks for the review.
> 
> I added the new fes-dynamic.patch patch, that required fixing
> and/or making compatible with automake 1.13 stuff and removing
> some duplicated entries in autogenerated file lists to avoid
> adding the same object files more than once to the linker
> command line (could add -Wl,mulrefs, but too ugly...)
> 
Do you've sent the patch to the upstream folks?

> I can remove the "with_doc" macro if you prefer. It was not added
> because of size of the pdf file (100kish) but kind or remaining
> of my initial tests in generating documentation, and figuring
> out what was required, and the almost full texlive stack is
> not always "cheap" to install.

You mean a local installation, in Mock or in a real environment? Of course, the texlive stuff eats up a lot of disk space and need much bandwith when updates come in. But I always try to build on a Koji server, so that I don't have to bother with that. Anyway, the doc creation is switched on (what I've missed on time I've written my first comments), so that you have to decide if it goes into a subpackage. I'm fine with the current solution, although the %with_doc macro is rather not needed.

Scratch build fails for Rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5476519

From build.log:

+ autoreconf -ifs
/var/tmp/rpm-tmp.QUDUtP: line 42: autoreconf: command not found

autoconf is missing from BuildRequires.
Comment 4 Paulo Andrade 2013-06-07 17:56:52 EDT
(In reply to Mario Blättermann from comment #3)
> (In reply to Paulo Andrade from comment #2)
> > Many thanks for the review.
> > 
> > I added the new fes-dynamic.patch patch, that required fixing
> > and/or making compatible with automake 1.13 stuff and removing
> > some duplicated entries in autogenerated file lists to avoid
> > adding the same object files more than once to the linker
> > command line (could add -Wl,mulrefs, but too ugly...)
> > 
> Do you've sent the patch to the upstream folks?

  I sent the patch to upstream.

> > I can remove the "with_doc" macro if you prefer. It was not added
> > because of size of the pdf file (100kish) but kind or remaining
> > of my initial tests in generating documentation, and figuring
> > out what was required, and the almost full texlive stack is
> > not always "cheap" to install.

  I asked upstream if it is desirable to have the doc built,
as he told me the documentation was done in a very quick way.

> You mean a local installation, in Mock or in a real environment? Of course,
> the texlive stuff eats up a lot of disk space and need much bandwith when
> updates come in. But I always try to build on a Koji server, so that I don't
> have to bother with that. Anyway, the doc creation is switched on (what I've
> missed on time I've written my first comments), so that you have to decide
> if it goes into a subpackage. I'm fine with the current solution, although
> the %with_doc macro is rather not needed.

  I removed the macro for now, the problem is getting the
environment right, after that the generated doc is very
small.

> Scratch build fails for Rawhide:
> http://koji.fedoraproject.org/koji/taskinfo?taskID=5476519
> 
> From build.log:
> 
> + autoreconf -ifs
> /var/tmp/rpm-tmp.QUDUtP: line 42: autoreconf: command not found
> 
> autoconf is missing from BuildRequires.

Also fixed.

Update:

- Add missing autoconf, automake and libtool build requires (#914936#c3).
- Remove the with_doc macro (#914936#c3).
- Change package to be x86_64 specific, as sse2 is not optional.

Spec URL: http://pcpa.fedorapeople.org/fes.spec
SRPM URL: http://pcpa.fedorapeople.org/fes-0.1-3.fc20.src.rpm
Comment 5 Mario Blättermann 2013-06-08 05:30:26 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5483055

$ rpmlint -i -v *
fes.src: I: checking
fes.src: W: spelling-error %description -l en_US boolean -> Boolean, boo lean, boo-lean
The value of this tag appears to be misspelled. Please double-check.

fes.src: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes.src: I: checking-url http://www.lifl.fr/~bouillag/download/fes-0.1.spkg (timeout 10 seconds)
fes.x86_64: I: checking
fes.x86_64: W: spelling-error %description -l en_US boolean -> Boolean, boo lean, boo-lean
The value of this tag appears to be misspelled. Please double-check.

fes.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes.x86_64: W: executable-stack /usr/lib64/libfes.so.0.0.0
The binary declares the stack as executable.  Executable stack is usually an
error as it is only needed if the code contains GCC trampolines or similar
constructs which uses code on the stack.  One common source for needlessly
executable stack cases are object files built from assembler files which don't
define a proper .note.GNU-stack section.

fes.x86_64: E: library-without-ldconfig-postin /usr/lib64/libfes.so.0.0.0
This package contains a library and provides no %post scriptlet containing a
call to ldconfig.

fes.x86_64: E: library-without-ldconfig-postun /usr/lib64/libfes.so.0.0.0
This package contains a library and provides no %postun scriptlet containing a
call to ldconfig.

fes-debuginfo.x86_64: I: checking
fes-debuginfo.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes-devel.x86_64: I: checking
fes-devel.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes.spec: I: checking-url http://www.lifl.fr/~bouillag/download/fes-0.1.spkg (timeout 10 seconds)
4 packages and 1 specfiles checked; 2 errors, 3 warnings.


The executable-stack warning needs to be investigated.

Moreover, the main package is missing the ldconfig call:
http://fedoraproject.org/wiki/Packaging:Guidelines#Shared_Libraries
Comment 6 Paulo Andrade 2013-06-08 13:40:27 EDT
The boolean instead of Boolean should be correct, it is common usage,
that is, not referring to http://en.wikipedia.org/wiki/George_Boole
just the notation of true or false, and is a verbatim copy of the
upstream definition.

I corrected the two extra issues.

Update:

- Add ldconfig to post and postun (#914936#c5).
- Mark stack as not executable in .s to .o compilation (#914936#c5).

Spec URL: http://pcpa.fedorapeople.org/fes.spec
SRPM URL: http://pcpa.fedorapeople.org/fes-0.1-4.fc20.src.rpm
Comment 7 Mario Blättermann 2013-06-09 03:48:26 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5484808

$ rpmlint -i -v *
fes.src: I: checking
fes.src: W: spelling-error %description -l en_US boolean -> Boolean, boo lean, boo-lean
The value of this tag appears to be misspelled. Please double-check.

fes.src: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes.src: I: checking-url http://www.lifl.fr/~bouillag/download/fes-0.1.spkg (timeout 10 seconds)
fes.x86_64: I: checking
fes.x86_64: W: spelling-error %description -l en_US boolean -> Boolean, boo lean, boo-lean
The value of this tag appears to be misspelled. Please double-check.

fes.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes-debuginfo.x86_64: I: checking
fes-debuginfo.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes-devel.x86_64: I: checking
fes-devel.x86_64: I: checking-url http://www.lifl.fr/~bouillag (timeout 10 seconds)
fes.spec: I: checking-url http://www.lifl.fr/~bouillag/download/fes-0.1.spkg (timeout 10 seconds)
4 packages and 1 specfiles checked; 0 errors, 2 warnings.

OK.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv3+
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    12790fb053fdf093f10c27f74d35998f2740a9f081800c4502e06314863ee13c  fes-0.1.spkg
    12790fb053fdf093f10c27f74d35998f2740a9f081800c4502e06314863ee13c  fes-0.1.spkg.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[+] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[+] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[.] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 8 Paulo Andrade 2013-06-09 14:49:25 EDT
Many thanks for the review!

New Package SCM Request
=======================
Package Name: fes
Short Description: Fast Exhaustive Search
Owners: pcpa
Branches: f18 f19
InitialCC:
Comment 9 Jon Ciesla 2013-06-10 07:50:40 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2013-06-10 15:26:47 EDT
fes-0.1-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/fes-0.1-4.fc19
Comment 11 Fedora Update System 2013-06-10 16:14:41 EDT
fes-0.1-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/fes-0.1-4.fc18
Comment 12 Fedora Update System 2013-06-11 13:58:24 EDT
fes-0.1-4.fc19 has been pushed to the Fedora 19 testing repository.
Comment 13 Fedora Update System 2013-06-20 22:02:03 EDT
fes-0.1-4.fc18 has been pushed to the Fedora 18 stable repository.
Comment 14 Fedora Update System 2013-06-29 14:48:47 EDT
fes-0.1-4.fc19 has been pushed to the Fedora 19 stable repository.